import { TerraDrawMouseEvent, TerraDrawAdapterStyling, TerraDrawKeyboardEvent, HexColorStyling, NumericStyling, Cursor } from "../../common";
import { TerraDrawBaseDrawMode, BaseModeOptions, CustomStyling } from "../base.mode";
import { BehaviorConfig } from "../base.behavior";
import { GeoJSONStoreFeatures } from "../../store/store";
type TerraDrawPolygonModeKeyEvents = {
    cancel?: KeyboardEvent["key"] | null;
    finish?: KeyboardEvent["key"] | null;
};
type PolygonStyling = {
    fillColor: HexColorStyling;
    outlineColor: HexColorStyling;
    outlineWidth: NumericStyling;
    fillOpacity: NumericStyling;
    closingPointWidth: NumericStyling;
    closingPointColor: HexColorStyling;
    closingPointOutlineWidth: NumericStyling;
    closingPointOutlineColor: HexColorStyling;
};
interface Cursors {
    start?: Cursor;
    close?: Cursor;
}
interface TerraDrawPolygonModeOptions<T extends CustomStyling> extends BaseModeOptions<T> {
    allowSelfIntersections?: boolean;
    snapping?: boolean;
    pointerDistance?: number;
    keyEvents?: TerraDrawPolygonModeKeyEvents | null;
    cursors?: Cursors;
}
export declare class TerraDrawPolygonMode extends TerraDrawBaseDrawMode<PolygonStyling> {
    mode: string;
    private currentCoordinate;
    private currentId;
    private allowSelfIntersections;
    private keyEvents;
    private snappingEnabled;
    private snapping;
    private pixelDistance;
    private closingPoints;
    private cursors;
    private mouseMove;
    constructor(options?: TerraDrawPolygonModeOptions<PolygonStyling>);
    private close;
    /** @internal */
    registerBehaviors(config: BehaviorConfig): void;
    /** @internal */
    start(): void;
    /** @internal */
    stop(): void;
    /** @internal */
    onMouseMove(event: TerraDrawMouseEvent): void;
    /** @internal */
    onClick(event: TerraDrawMouseEvent): void;
    /** @internal */
    onKeyUp(event: TerraDrawKeyboardEvent): void;
    /** @internal */
    onKeyDown(): void;
    /** @internal */
    onDragStart(): void;
    /** @internal */
    onDrag(): void;
    /** @internal */
    onDragEnd(): void;
    /** @internal */
    cleanUp(): void;
    /** @internal */
    styleFeature(feature: GeoJSONStoreFeatures): TerraDrawAdapterStyling;
    validateFeature(feature: unknown): feature is GeoJSONStoreFeatures;
}
export {};
